/*
 * EditorClipboard.java
 *
 * Created on 3 luglio 2003, 15.38
 */

package myeditor;

import java.awt.datatransfer.*;
import java.io.*;

/**
 *
 * @author  Giulio Destri
 */
public class EditorClipboard {
    
    // clipboard condivisa con il sistema
    Clipboard a_clipboard;
    
    /** Creates a new instance of EditorClipboard */
    public EditorClipboard() {
        a_clipboard = new Clipboard("Java Editor Clipboard");
    } // end costruttore
    
     /**
      * insertString: inserisce una stringa nella clipboard
      * Creation date: (03/07/2003 15.40.22)
      * @param java.lang.String p_testo
      */ 
    public void insertString(String p_testo) {
        StringSelection temp_testo = new StringSelection(p_testo);
        String nulla = new String("");
        
        a_clipboard.setContents(temp_testo,temp_testo);      
    } // end insertString
    
     /**
      * extractString: inserisce una stringa nella clipboard
      * Creation date: (03/07/2003 15.40.22)
      * @param java.lang.String p_testo
      */ 
    public String extractString() {
        StringSelection temp_testo = null;
        String res = null;
        
        temp_testo = (StringSelection) a_clipboard.getContents((Object)temp_testo);      
        if (temp_testo != null) {
            try {
                res = (String) temp_testo.getTransferData(DataFlavor.stringFlavor); 
            } catch (UnsupportedFlavorException ufe) {
                System.err.println("UnsupportedFlavorException caught");
            } catch ( IOException ioe) {
                System.err.println("IOException caught");
            }
        } else {
            res = new String("");
        }
        return res;
    } // end insertString
    
}
