/*
 * GestoreMemoriaRubrica.java
 *
 * Created on 20 settembre 2003, 12.57
 * @author: Giulio Destri
 */

package rubricaLib;

import java.util.*;
import java.sql.*;
import java.io.*;

import entityLib.Persona;
import exceptionLib.RubricaException;

/**
 *
 * @author  Giulio Destri
 */
public class GestoreMemoriaRubrica {
    
    private Vector listaPersone;
    private int posizioneCorrente;
    
    private GestoreDBRubrica gdbr;
    
   
    /** 
     * Creates a new instance of GestoreRubrica 
     * Costruttore, richiama il metodo di connessione al DB
     */
    public GestoreMemoriaRubrica() {
        listaPersone = new Vector();
     //   inizializzaRubrica();
        posizioneCorrente = 0;
        gdbr = new GestoreDBRubrica();
        //caricaRubricaDB();
    }
    
         
    public void setPosizioneCorrente(int p_posizione)  {
        posizioneCorrente= p_posizione;
    }
    
    
    public int getPosizioneCorrente()  {
        return posizioneCorrente;
    }
    
    public int getSize()  {
        return listaPersone.size();
    }    
    
    /**
     * Memorizza in listaPersone l'insieme degli oggetti Persona
     * caricati dal Database, e ritorna la prima Persona trovata
     * affinche' venga visualizzata nei 3 textfield della GUI
     * @param String p_cognome la chiave cognome
     */
 
    public Persona cercaPerCognome(java.lang.String p_cognome) throws RubricaException {
                
        // Persona da ritornare
	Persona res=null;
        
        // Vettore di persone locale 
        Vector tempListaPersone;
        
        // carica la lista di persone dal database
        tempListaPersone = gdbr.cercaPerCognomeDB(p_cognome);
        
        // se non e' nullo
        if (tempListaPersone != null) {
            // lo assegna all'attributo globale
            listaPersone = tempListaPersone;
        }
        
        // estrae il primo elemento trovato
        res = (Persona)listaPersone.get(0);
        
        // azzera l'indice del Vettore
        posizioneCorrente = 0;
    
        // se e' ancora vuoto
        if (res==null) {
            res = new Persona("","","");
        }
        
        // ritorna il risultato
        return res;
        
    } // end cercaPerCognome
    
    public Persona cercaPerNome(java.lang.String p_nome) throws RubricaException {
        
        // persona da ritornare
        Persona res=null;
        
        // Vettore di persone locale 
        Vector tempListaPersone;
        
        // carica la lista di persone dal database
        tempListaPersone = gdbr.cercaPerNomeDB(p_nome);
        
        // se non e' nullo
        if (tempListaPersone != null) {
            // lo assegna all'attributo globale
            listaPersone = tempListaPersone;
        }
        
        // estrae il primo elemento trovato
        res = (Persona)listaPersone.get(0);

        // azzera l'indice del Vettore
        posizioneCorrente = 0;
             
        // se e' ancora vuoto
        if (res==null) {
            res = new Persona("","","");
        }
        
        // ritorna il risultato
        
        return res;
    }
    
    public Persona cercaPerNumtel(java.lang.String p_numtel) throws RubricaException {
        
        // persona da ritornare
        Persona res=null;
        
        // Vettore di persone locale 
        Vector tempListaPersone;
        
        // carica la lista di persone dal database
        tempListaPersone = gdbr.cercaPerNumtelDB(p_numtel);
        
        // se non e' nullo
        if (tempListaPersone != null) {
            // lo assegna all'attributo globale
            listaPersone = tempListaPersone;
        }
        
        // estrae il primo elemento trovato
        res = (Persona)listaPersone.get(0);
        
        // azzera l'indice del Vettore
        posizioneCorrente = 0;
          
        // se e' ancora vuoto
        if (res==null) {
            res = new Persona("","","");
        }
        
        // ritorna il risultato
        
        return res;
    }  // end cerca numtel
    
    
    public Persona getFirst() {
        Persona res;
        
        posizioneCorrente = 0;
        
        res = (Persona)listaPersone.get(0);
        return res;
        
    }  // end getFirst
    
    public Persona getLast() {
        Persona res;
        
        posizioneCorrente = listaPersone.size()-1;
        
        res = (Persona)listaPersone.get(posizioneCorrente);
        return res;
        
    }  // end getFirst
    
    public Persona getNext() {
        Persona res;
        
        if (posizioneCorrente < (listaPersone.size()-1)) {
            posizioneCorrente = posizioneCorrente + 1;
        } // end if
        else {
            posizioneCorrente = listaPersone.size()-1;
        } // end else
        
        res = (Persona)listaPersone.get(posizioneCorrente);
        return res;
        
    }  // end getNext
    
    public Persona getPrevious() {
        Persona res;
        
    if (posizioneCorrente > 0) {
            posizioneCorrente = posizioneCorrente - 1;
        } // end if
        else {
            posizioneCorrente = 0;
        } // end else
         
        res = (Persona)listaPersone.get(posizioneCorrente);
        return res;
        
    }  // end getPrevious
    
    // fine delle ricerche
    
   public void inizializzaRubrica() {
        Persona temp;
        
        temp = new Persona("Giulio", "Destri", "11111");
        boolean b = listaPersone.add((Object)temp);
         //add(1,(Object)temp);
        
        temp = new Persona("Oscar", "Figus", "22222");
        b = listaPersone.add((Object)temp);
        
        temp = new Persona("Cesare", "Chiodelli", "33333");
        b = listaPersone.add((Object)temp);
        
    }
    
    public void inserisciNuovo(Persona p_persona) {
        boolean b = listaPersone.add((Object)p_persona);
        gdbr.inserisciNuovoDB(p_persona);
    } // end method inserisciNuovo
    
 
    public void cancella(int p_posizione) {
        Persona temporaneo;
        // estrare l'elemento rimuovendolo dal Vector
        temporaneo = (Persona) listaPersone.remove(p_posizione);
        
        gdbr.cancellaDB(temporaneo);
        
        if (posizioneCorrente != 0) {
            posizioneCorrente--;
        }
    } // end method cancella

    public void rimpiazza(Persona p_persona, int p_posizione) {
        Persona temporaneo;
        
        temporaneo = (Persona) listaPersone.remove(p_posizione);
        posizioneCorrente = p_posizione;
        gdbr.rimpiazzaDB(p_persona, temporaneo);
        listaPersone.insertElementAt((Object)p_persona,p_posizione);
    } // end method rimpiazza
    
    public void caricaRubrica(String p_filename) {
	Persona temporaneo = null;
	String temp_string;
	String separatore = ",";
        
        BufferedReader inputFile; 
        String inputLine;
        StringTokenizer tokenizer;
        
        String f_cognome = "";
        String f_nome = "";
        String f_numtel = "";
        
        try {
            // apre il file in lettura
            inputFile = new BufferedReader(new FileReader(p_filename));
        
            // legge il file riga per riga
            inputLine = inputFile.readLine();
            while (inputLine != null) {
                System.out.println(inputLine);
                // imposta il tokenizzatore per inputLine, con la stringa separatore a fare da separatore
                tokenizer = new StringTokenizer(inputLine,separatore);
                
                // se gli elementi della riga non sono 3
                if (tokenizer.countTokens() != 3) {
                    System.out.println(
                        "numero di token"+
                        tokenizer.countTokens()+
                        "ERRORE nella riga");
                } else  {
                    f_cognome = tokenizer.nextToken();
                    f_nome = tokenizer.nextToken();
                    f_numtel = tokenizer.nextToken();
                                 
                    
                    temporaneo = new Persona(f_nome, f_cognome, f_numtel);
                    listaPersone.addElement((Object)temporaneo);
                }
                  
                inputLine = inputFile.readLine();
            } // end while

            // chiude il file 
            inputFile.close();
       
    
        // gestione delle varie eccezioni possibili con i file
	} catch(FileNotFoundException e) {
		System.err.println("File Not Found!");
	} catch(IOException e) {
		System.err.println("I/Oerr");
	} catch(IllegalArgumentException e) {
		System.err.println ("java FileCopy srcdest");
	} finally { /*
		try {
                    //if (inputFile != null) inputFile.close();
		} catch(IOException e) {
                    System.err.println("I/O err");
		} */
	}
    } // end method caricaRubrica
    
    /**
     * salvaRubrica: salva la rubrica su file
     * Creation date: (30/10/2002 16.40.22)
     * @param p_filename java.lang.String
     */
    public void salvaRubrica(String p_filename) {
	Persona temporaneo = null;
	String temp_string;
	FileOutputStream fout= null;
        String separatore = ",";

	try {
            
            // apre il file in scrittura
            fout = new FileOutputStream(p_filename);
            
            // conta le persone presenti nella lista
            int numpersone = listaPersone.size();
            
            // per ciascuna persona
            for (int i=0;i<numpersone;i++){
                
                // estrae un elemento temporaneo
                temporaneo = (Persona)listaPersone.elementAt(i);
                
                // lo converte in stringa estraendone gli attributi
                temp_string=temporaneo.getCognome() +
                    separatore +
                    temporaneo.getNome() +
                    separatore +
                    temporaneo.getNumtel();
                
                // trasforma la stringa in un array di byte (compatibile ASCII)
                byte b[]=temp_string.getBytes();
                
                // scrive l'array nel file
	        fout.write(b);
                
                // definisce il fineriga e lo aggiunge al file
	        byte finRiga[] = "\r\n".getBytes();
	        fout.write(finRiga);
                
            } // end for 
        
            // chiude il file
            fout.close();
            
        // gestione delle varie eccezioni possibili con i file
	} catch(FileNotFoundException e) {
		System.err.println("File Not Found!");
	} catch(IOException e) {
		System.err.println("I/Oerr");
	} catch(IllegalArgumentException e) {
		System.err.println ("java FileCopy srcdest");
	} finally {
		try {
			if (fout != null) fout.close();
		} catch(IOException e) {
			System.err.println("I/O err");
		}
	}
    } // end method salvaRubrica       
     
} // end class GestoreMemoriaRubrica
