/*
 * ConvAdapter.java
 *
 * Created on 5 luglio 2004, 16.11
 */

/**
 *
 * @author  gdestri
 */
package serviceLib;

public class ConvAdapter {
    Convertitore conv;
    
    /** Creates a new instance of ConvAdapter */
    public ConvAdapter() {
        conv = new Convertitore();
    }
    
     public String euroToDollaro(String p_euro) {
        double euro;
        double dollaro; 
        try {
            euro = Double.parseDouble(p_euro);
            dollaro = conv.euroToDollaro(euro);
        } catch (NumberFormatException e){
            System.out.println("Errore di formato: dato non valido!");
            dollaro = 0.0;
        }
        return Double.toString(dollaro);
    } // end method euroToDollaro
    
    public String dollaroToEuro(String p_dollaro) {
        double euro;
        double dollaro; 
        try {
            dollaro = Double.parseDouble(p_dollaro);
            euro = conv.dollaroToEuro(dollaro);
        } catch (NumberFormatException e){
            System.out.println("Errore di formato: dato non valido!");
            euro = 0.0;
        }
        return Double.toString(euro);
    } // end method dollaroToEuro
    
    public String getTasso() {
        return Double.toString(conv.getTasso());
    } // end method getTasso
    
    public void setTasso(String p_tasso) {
        double tasso;
        try { 
            tasso = Double.parseDouble(p_tasso);
        } catch (NumberFormatException e){
            System.out.println("Errore di formato: dato non valido!");
            tasso = conv.getTasso();
        } 
        conv.setTasso(tasso);
    } // end method setTasso
    
} // end class ConvAdapter
