/*
 * ConvertitoreValuta.java
 *
 * Created on 22 febbraio 2003, 1.13
 */

package serviceLib;

/**
 *
 * @author  Giulio Destri
 */
public class ConvertitoreValuta {
    
    /** attributo per il fattore di Tasso di Cambio */
    private double ad_fattoreConversione;
    
    /** Costruttore: Crea una nuova istanza di ConvertitoreValuta */
    public ConvertitoreValuta() {
        // impostazione del fattore conversione a un valore di default
        ad_fattoreConversione = 1.07;
    }
    
    /** Converte da dollari a euro */
    public double dollariToEuro(double pd_dollari) {
        return pd_dollari / ad_fattoreConversione;
    }
    
    /** Converte da euro a dollari */
    public double euroToDollari(double pd_euro) {
        return pd_euro * ad_fattoreConversione;
    }
    
    /** Imposta il valore di conversione da dollari a euro */
    public void setFattoreConversione(double pd_fc) {
        ad_fattoreConversione = pd_fc;
    }
    
    /** Ritorna il valore corrente del fattore 
        di conversione da dollari a euro */
    public double getFattoreConversione() {
        return ad_fattoreConversione;
    }
    
} // end class ConvertitoreValuta
