/*
 * ConvertitoreServlet.java
 *
 * Created on 5 luglio 2004, 17.13
 */

package webGui;

import java.io.*;
import java.net.*;

import javax.servlet.*;
import javax.servlet.http.*;

import serviceLib.*;

/**
 *
 * @author  gdestri
 * @version
 */
public class ConvertitoreServlet extends HttpServlet {
    
    ConvAdapter ca = new ConvAdapter();
    
    /** Initializes the servlet.
     */
    public void init(ServletConfig config) throws ServletException {
        super.init(config);
        
    }
    
    /** Destroys the servlet.
     */
    public void destroy() {
        
    }
    
    /** Processes requests for both HTTP <code>GET</code> and <code>POST</code> methods.
     * @param request servlet request
     * @param response servlet response
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        
        String euroString = "";
        String dollaroString = "";
        String tassoString = "";
        
        String euroSubString = request.getParameter("euroSubmit");
        String dollaroSubString = request.getParameter("dollaroSubmit");
        String tassoSubString = request.getParameter("tassoSubmit");
        
        if (tassoSubString != null) {
            tassoString = request.getParameter("tassoText");
            if ((tassoString != null) || (!(tassoString.equals("")))) {
                ca.setTasso(tassoString);
            }
        } // end if 

        if (euroSubString != null) {
            euroString = request.getParameter("euroText");
            if ((euroString != null) || (!(euroString.equals("")))) {
                dollaroString = ca.euroToDollaro(euroString);
            }
        } // end if 

        if (dollaroSubString != null) {
            dollaroString = request.getParameter("dollaroText");
            if ((dollaroString != null) || (!(dollaroString.equals("")))) {
                euroString = ca.dollaroToEuro(dollaroString);
            }
        } // end if 
        
        // sono state ottenute le stringhe di ritorno con i valori calcolati
               
        // le aggancia all'oggetto request con identificatore "euroParam"...
        request.setAttribute("euroParam", euroString);
        request.setAttribute("dollaroParam", dollaroString);
        request.setAttribute("tassoParam", tassoString);
        
        // e passa il controllo alla pagina JSP
        request.getRequestDispatcher("convertitore/ConvertitoreView.jsp").forward(request, response);
        
        
        
    }
    
    /** Handles the HTTP <code>GET</code> method.
     * @param request servlet request
     * @param response servlet response
     */
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        processRequest(request, response);
    }
    
    /** Handles the HTTP <code>POST</code> method.
     * @param request servlet request
     * @param response servlet response
     */
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        processRequest(request, response);
    }
    
    /** Returns a short description of the servlet.
     */
    public String getServletInfo() {
        return "Short description";
    }
    
} // end class ConvertitoreServlet